import 'package:b2b_graphql_package/GraphQLConfiguration.dart';
import 'package:b2b_graphql_package/modules/account/user_address_model.dart';
import 'package:graphql_flutter/graphql_flutter.dart';
import 'user_model.dart';

class UserRepo {
  var graphQLConfiguration;

  var userDetails;
  var userAddressDetails = [];
  UserRepo() {
    graphQLConfiguration = GraphQLConfiguration();
  }
  // Future<bool> addUser(UserModel userModel) async {
  //   String addUserGql =
  //       """mutation addUser( \$sdgsdg: String,\$lastName: String,\$mobileNumber: Float,
  //       \$email: String,\$pwd: String) {
  //                       addUser(userInput:{firstName: \$sdgsdg,
  //                 lastName: \$lastName,
  //                 mobileNumber:\$mobileNumber,
  //                 email:\$email,
  //                 pwd:\$pwd})
  //                               {
  //                                 id
  //                               }
  //                   }""";
  //   GraphQLConfiguration graphQLConfiguration = GraphQLConfiguration();
  //   GraphQLClient _client = graphQLConfiguration.clientToQuery();
  //   final vble = {
  //     "sdgsdg": userModel.firstName,
  //     "lastName": userModel.lastName
  //   };
  //   QueryResult result = await _client.mutate(
  //     MutationOptions(
  //       document: gql(addUserGql),
  //       variables: vble,
  //     ),
  //   );
  //   if (!result.hasException) {
  //     return true;
  //   }
  //   return false;
  // }

  Future getUserById(String id) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var getUserByIdGql = """ 
                query getByUserId(\$id: String) {
                getByUserId(id: \$id) {
                  _id
                  contactName
                  companyName
                  mobileNumber
                  emailId
                  altMobileNumber
                  __typename
                }
              }

            """;

    final vble = {
      "id": id,
    };
    QueryResult result = await _client.query(QueryOptions(
      document: gql(getUserByIdGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    try {
      if (!result.hasException) {
        var userDetailsModel = result.data!['getByUserId'];

        if (userDetailsModel != null && userDetailsModel.length > 0) {
          userDetails = userByIdFromJson(userDetailsModel);
          return userDetails;
        }
      }
      return userDetails;
    } catch (e) {
      print(e);
      return userDetails;
    }
  }

  Future getUserByAddress(String id) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var getUserByAddressGql = """ 
                query getByUserIdAddress(\$id: String) {
                getByUserIdAddress(id: \$id) {
                  _id
                  companyName
                  contactName
                  emailId
                  address
                  mobileNumber
                  pinCode
                  country
                  state
                  city
                  billingAddress
                  __typename
                }
              }

            """;

    final vble = {
      "id": id,
    };
    QueryResult result = await _client.query(QueryOptions(
      document: gql(getUserByAddressGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    try {
      if (!result.hasException) {
        var userAddressDetailsModel = result.data!['getByUserIdAddress'];

        if (userAddressDetailsModel != null &&
            userAddressDetailsModel.length > 0) {
          userAddressDetails = userByAddressFromJson(userAddressDetailsModel);
          return userAddressDetails;
        }
      }
      return userAddressDetails;
    } catch (e) {
      print(e);
      return userAddressDetails;
    }
  }
}
